/* tslint:disable */
/* eslint-disable */
/**
* @param {string} cpb_k
* @param {string} spk
* @param {string} share_key
* @param {string} message
* @param {string} signature
* @param {bigint} timestamp
* @returns {string}
*/
export function decrypt_vm(cpb_k: string, spk: string, share_key: string, message: string, signature: string, timestamp: bigint): string;
/**
* @param {string} cpv_k
* @param {string} spk
* @param {string} share_key
* @param {string} message
* @returns {string}
*/
export function encrypt_vm(cpv_k: string, spk: string, share_key: string, message: string): string;
/**
* @param {string} token
* @returns {string}
*/
export function init_vm(token: string): string;

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly decrypt_vm: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number) => void;
  readonly encrypt_vm: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => void;
  readonly init_vm: (a: number, b: number, c: number) => void;
  readonly __wbindgen_add_to_stack_pointer: (a: number) => number;
  readonly __wbindgen_malloc: (a: number) => number;
  readonly __wbindgen_realloc: (a: number, b: number, c: number) => number;
  readonly __wbindgen_free: (a: number, b: number) => void;
  readonly __wbindgen_exn_store: (a: number) => void;
}

/**
* Synchronously compiles the given `bytes` and instantiates the WebAssembly module.
*
* @param {BufferSource} bytes
*
* @returns {InitOutput}
*/
export function initSync(bytes: BufferSource): InitOutput;
export function initLocal(): Promise<InitOutput>;
/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
